var canvas;
var cntx;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    drawBasicScreen();
}
      
function initialiseEvents(){
    $(document).keyup(function(e){
        if(e.keyCode==144){//NumLock
            drawBasicScreen();
        }
    });
    
    $($(document)).on("input","#crypto", function(){
        drawBasicScreen();
    });

    $("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });

    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
    });

    $("#visualisation").on("mousedown touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseDown();
    });
} 

function initialiseGUI(){

}

function initialValues(){
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
    imgNxtStepEnabled=document.getElementById("ButtonEnabledSmall");
    imgNxtStepSelected=document.getElementById("ButtonSelSmall");
    imgBackStepEnabled=document.getElementById("BackEnabledSmall");
    imgBackStepSelected=document.getElementById("BackSelSmall");
    nxtStepLeft=width-nxtStepWidth-15-logoWidth;
    nxtStepTop=BottomPanelTop+20;
    BackStepLeft=2;
    BackStepTop=nxtStepTop;
}

function drawBasicScreen(){
    cntx.clearRect(0,0,canvas.width,canvas.height);
    //Φόντα οθόνης
    drawIntroImage();
    drawLogoImage();
    if(IntroStep<IntroLastStep) drawButtonNext();
    if(IntroStep>1) drawButtonBack();
    if(IntroStep==IntroTestASCIIStep){
        $("#controlsDiv1").show();
    }
    else{
        $("#controlsDiv1").hide();
    }
    if(IntroStep==IntroCrypto1Step || IntroStep==IntroCrypto2Step){
        $("#controlsDiv2").show();
        cnvsWrite(LetterColor,fontSize+4,"Arial",262,133,""+CharOffset);
        DrawCipherMatrix();
        DrawCodedMessage();
    }
    else{
        $("#controlsDiv2").hide();
    }
    showUserPrompts();
}

function drawIntroImage(){
    Intro=document.getElementById("img"+IntroStep);
    var picTop=(height-Intro.height)/2;
    cntx.strokeStyle="black";
    //πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    //άνω πλαίσιο
    cntx.rect(0,0,width,picTop-1);
    //κάτω πλαίσιο
    var lowRectTop=picTop+Intro.height+1;
    cntx.rect(0,lowRectTop,width,height-lowRectTop);

    cntx.stroke();
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    cntx.drawImage(Intro,1,picTop);
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+1;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function drawButtonNext(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonNextHover()){
        cntx.drawImage(imgNxtStepSelected,nxtStepLeft,nxtStepTop);
    }
    else{
        cntx.drawImage(imgNxtStepEnabled,nxtStepLeft,nxtStepTop);
    }
}

function buttonNextHover(){
    if (mx>=nxtStepLeft && mx<=nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<=nxtStepTop+nxtStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function drawButtonBack(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonBackHover()){
        cntx.drawImage(imgBackStepSelected,BackStepLeft,BackStepTop);
    }
    else{
        cntx.drawImage(imgBackStepEnabled,BackStepLeft,BackStepTop);
    }
}

function buttonBackHover(){
    if (mx>=BackStepLeft && mx<=BackStepLeft+BackStepWidth && my>=BackStepTop && my<=BackStepTop+BackStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){
}

function handleMouseMove(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else{
        imgLogo=document.getElementById("Logo");
    }
    if(IntroStep==IntroCrypto1Step || IntroStep==IntroCrypto2Step){
        if(SpinButtonsHover()){
            canvas.style.cursor="pointer";
        }
        else {
            canvas.style.cursor="default";
        }
    }
    drawBasicScreen();
    //console.log("mx="+mx+" , my="+my);
}

function handleMouseUp(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight) {
        showHTML();
    }
    if(mx>=nxtStepLeft && mx<nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<nxtStepTop+nxtStepHeight && IntroStep<IntroLastStep) {
        IntroStep++;
        $("#crypto").val("");
        drawBasicScreen();
    }
    if(mx>=BackStepLeft && mx<BackStepLeft+BackStepWidth && my>=BackStepTop && my<BackStepTop+BackStepHeight && IntroStep>1) {
        IntroStep--;
        $("#crypto").val("");
        drawBasicScreen();
    }
    if((IntroStep==IntroCrypto1Step ||IntroStep==IntroCrypto2Step) && SpinButtonsHover()){
        if(my<173){
            IncreaseCharOffset();
        }
        else{
            DecreaseCharOffset();
        }
        drawBasicScreen();
    }
}

function showUserPrompts(){
    var vTxtOffset=15;
    var promptYCoord;
    promptYCoord=BottomPanelTop+15;
    if(IntroStep==IntroTestASCIIStep){
        if(NumLockOff(event)){
            cnvsWrite("red",18,"Arial",70,promptYCoord+25,"Για να λειτουργήσει η μέθοδος θα πρέπει να πατήσεις το πλήκτρο NumLock.");
        }
    }
    else if(IntroStep==IntroCrypto1Step){
        cnvsWrite(LetterColor,fontSize-1,"Arial",45,promptYCoord,"Τροποποίησε την αντιστοιχία των χαρακτήρων κάνοντας κλικ στα βέλη. Πληκτρολόγησε το μήνυμά σου");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize-1,"Arial",45,promptYCoord,"με κεφαλαίους ελληνικούς χαρακτήρες. Μπορείς να συμπεριλάβεις και άλλα σύμβολα, π.χ. αριθμητικά ψηφία, ");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize-1,"Arial",45,promptYCoord,"κενά, σημεία στίξης, λατινικούς χαρακτήρες, κ.λπ. Ο υπολογιστής σου όμως δεν θα τα κωδικοποιήσει.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize-1,"Arial",45,promptYCoord,"Θα χρειαστείς ένα πληρέστερο πρόγραμμα για το σκοπό αυτό, το οποίο μπορείς να βρεις στην επόμενη οθόνη.");
    }
    else if(IntroStep==IntroCrypto2Step){
        cnvsWrite(LetterColor,fontSize,"Arial",60,promptYCoord,"Τροποποίησε την αντιστοιχία των χαρακτήρων κάνοντας κλικ στα βέλη.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",60,promptYCoord,"Πληκτρολόγησε το μήνυμά σου στο λευκό πλαίσιο.");
    }
}

function NumLockOff(event){
    return !event.getModifierState("NumLock");
}

function SpinButtonsHover(){
    return (mx>22 && mx<38 && my>155 && my<188);
}

function IncreaseCharOffset(){
    if(CharOffset<15) CharOffset++;
}

function DecreaseCharOffset(){
    if(CharOffset>-15) CharOffset--;
}

function DrawCipherMatrix(){
    var i,LtrWidth,XCoord,LtrIndx;
    var VisibleLimit=0,AlphabetToUse=0;
    if(IntroStep==IntroCrypto1Step){
        VisibleLimit=NoOfLettersToShow;
        AlphabetToUse=24;
    }
    else if(IntroStep==IntroCrypto2Step){
        VisibleLimit=NoOfLettersToShow+NoOfLettersToShow2;
        AlphabetToUse=VisibleLimit;
    }
    //backg.setColor(new Color(0,0,255));
    //backg.setFont(new Font("Dialog",Font.BOLD,14));
    //fm=backg.getFontMetrics();
    for(i=0;i<NoOfLettersToShow;i++) {
        LtrIndx=getCipher(Letter[i],AlphabetToUse);
        while(LtrIndx>VisibleLimit-1){
            LtrIndx=LtrIndx-VisibleLimit;
        }
        LtrWidth=cntx.measureText(Letter[LtrIndx]).width;
        XCoord=parseInt((26-LtrWidth)/2);
        //backg.drawString(Letter[LtrIndx],83+i*26+XCoord,195);
        cnvsWrite(LetterColor,fontSize,"Arial",83+i*26+XCoord,195,Letter[LtrIndx]);
    }
    if(IntroStep==IntroCrypto2Step){
        for(i=24;i<VisibleLimit;i++) {
            LtrIndx=getCipher(Letter[i],AlphabetToUse);             
            while(LtrIndx>VisibleLimit-1){
                LtrIndx=LtrIndx-VisibleLimit;
            }
            LtrWidth=cntx.measureText(Letter[LtrIndx]).width;
            XCoord=parseInt((26-LtrWidth)/2);
            //backg.drawString(Letter[LtrIndx],83+(i-24)*26+XCoord,270);
            cnvsWrite(LetterColor,fontSize,"Arial",83+(i-24)*26+XCoord,270,Letter[LtrIndx]);
        }
    }
}

function getCipher(Ltr,AlphabetToUse){
    var i=-1,LtrIndx;
    do{
        i++;
    }while(i<NoOfLetters && !(Letter[i]==Ltr));
    if(i<AlphabetToUse){
        LtrIndx=(i+CharOffset) % AlphabetToUse;
        while(LtrIndx<0){
            LtrIndx=LtrIndx+AlphabetToUse;
        }
    }
    else{
        LtrIndx=-1;
    }
    return LtrIndx;
}

function DrawCodedMessage(){
    var Msg=$("#crypto").val();
    if(Msg.length>0){
        var CodedMsg="",SubString;
        var i,j,AlphabetToUse;
        if(IntroStep==IntroCrypto1Step){
            AlphabetToUse=24;
        }
        else {
            AlphabetToUse=NoOfLetters;
        }
        for(i=0;i<Msg.length;i++){
            SubString=Msg.substring(i,i+1);
            SubString=ExcludeStress(SubString);
            j=getCipher(SubString,AlphabetToUse);           
            if(j==-1){
                CodedMsg=CodedMsg+SubString;
            }
            else{
                CodedMsg=CodedMsg+Letter[j];
            }
        }
        cnvsWrite("blue",2*fontSize,"Arial",25,475,CodedMsg);
    }
}

function ExcludeStress(letter){
    var strReturn;
    if(CharOffset==0){
        strReturn=letter;
    }
    else{
        if(letter=="ά"){
            strReturn="α";
        }
        else if(letter=="Ά"){
            strReturn="Α";
        }
        else if(letter=="ή"){
            strReturn="η";
        }
        else if(letter=="Ή"){
            strReturn="Η";
        }
        else if(letter=="ί"){
            strReturn="ι";
        }
        else if(letter=="Ί"){
            strReturn="Ι";
        }
        else if(letter=="ύ"){
            strReturn="υ";
        }
        else if(letter=="Ύ"){
            strReturn="Υ";
        }
        else if(letter=="ό"){
            strReturn="ο";
        }
        else if(letter=="Ό"){
            strReturn="Ο";
        }
        else if(letter=="ώ"){
            strReturn="ω";
        }
        else if(letter=="Ώ"){
            strReturn="Ω";
        }
        else if(letter=="έ"){
            strReturn="ε";
        }
        else if(letter=="Έ"){
            strReturn="Ε";
        }
        else if(letter=="ϊ"){
            strReturn="ι";
        }
        else if(letter=="Ϊ"){
            strReturn="Ι";
        }
        else if(letter=="ϋ"){
            strReturn="υ";
        }
        else if(letter=="Ϋ"){
            strReturn="Υ";
        }
        else{
            strReturn=letter;
        }
    }
    return strReturn;
}